Codeforces Round #305 Mike and Feet(单调栈)

来源:互联网 发布:网络制式英文 编辑:程序博客网 时间:2024/05/14 04:03

B. Mike and Feet
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mike is the president of country What-The-Fatherland. There are n bears living in this country besides Mike. All of them are standing in a line and they are numbered from 1 to n from left to right. i-th bear is exactly ai feet high.

A group of bears is a non-empty contiguous segment of the line. The size of a group is the number of bears in that group. The strengthof a group is the minimum height of the bear in that group.

Mike is a curious to know for each x such that 1 ≤ x ≤ n the maximum strength among all groups of size x.

Input

The first line of input contains integer n (1 ≤ n ≤ 2 × 105), the number of bears.

The second line contains n integers separated by space, a1, a2, ..., an (1 ≤ ai ≤ 109), heights of bears.

Output

Print n integers in one line. For each x from 1 to n, print the maximum strength among all groups of size x.

Sample test(s)
input
101 2 3 4 5 4 3 2 1 6
output
6 4 4 3 3 2 2 1 1 1 

题意:给一个长度为n的数列,询问在长度为1~n的区间中的最小值是多少。

思路:用单调栈处理出每个数作为最小值的最大区间块,用数组l和r记录,比如数列5 3 4 1 2,对于数字3,就是l[2] = 0, r[2]= 2,对于两边分别补-1和n。然后用g[i]表示区间长度为i时的符合要求的最大值,最后因为数值随区间长度增加递减,所以从n-1到0将答案更新。

AC代码:

#include <cstdio>#include <cstring>#include <stack>#include <algorithm>using namespace std;int l[200020], r[200020], a[200020], g[200020], ans[200020];stack<int>stk;main() {    int n;    scanf("%d", &n);    for(int i = 0; i < n; i++) {        scanf("%d", &a[i]);    }    l[0] = -1;    stk.push(0);    for(int i = 1; i < n; i++) {        while(!stk.empty()&& a[i] <= a[stk.top()]){            stk.pop();        }        if(stk.empty()) l[i] = -1;        else l[i] = stk.top();        stk.push(i);    }    while(!stk.empty()) stk.pop();    stk.push(n - 1);    r[n - 1] = n;    for(int i = n - 2; i >= 0; i--) {        while(!stk.empty() && a[i] <= a[stk.top()]){            stk.pop();        }        if(stk.empty()) r[i] = n;        else r[i] = stk.top();        stk.push(i);    }    for(int i = 0; i < n; i++) g[r[i] - l[i] - 2] = max(g[r[i] - l[i] - 2], a[i]);    for(int i = n - 1; i >= 0; i--) ans[i] = max(ans[i + 1], g[i]);    for(int i = 0; i < n; i++) printf("%d ", ans[i]);    putchar('\n');}



0 0
原创粉丝点击